/*
 * find_Bessel_roots.c -- ʬˡ (bisection method)  Jn(x)=0 
 *
 *   β򾮤ꤷĿ
 *   ѥ gcc -o find_Bessel_roots find_Bessel_roots.c -lm
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void print(int N, int n, double *a)
{
  int i;
  printf("  k           %d,k                 J%d(%dk)\n", n, n, n);
  for (i = 1; i <= N; i++)
    printf("%3d %25.18e %15e %f\n", i-1, a[i], jn(n,a[i]), a[i]-a[i-1]);
}

int main(int argc, char **argv)
{
  int i, j, maxitr = 100;
  double a, b, c, eps;
  double fa, fb, fc;
  int n;
  int num_of_roots;
  double *roots;

  if (argc == 3) {
    n = atoi(argv[1]);
    num_of_roots = atoi(argv[2]);
  }
  else {
    printf("Jn κǽ N Ĥޤ\n");
    printf("n="); scanf("%d", &n);
    printf("N="); scanf("%d", &num_of_roots);
  }
  if ((roots = malloc(sizeof(double) * (num_of_roots + 1))) == NULL) {
    fprintf(stderr, "cannot allocate memory\n");
    exit(1);
  }
  a = 0.1; b = 0.2; eps = 5e-16;
  roots[0] = 0;
  fa = jn(n, a); fb = jn(n, b);
  for (i = 1; i <= num_of_roots; i++) {
    while (fa * fb > 0) {
      a = b; fa = fb;
      b += 0.1; fb = jn(n, b);
    }
    for (j = 0; j <= maxitr && (b - a) / a > eps; j++) {
      c = (a + b) / 2; fc = jn(n, c);
      if (fc == 0.0)
        break;
      else if (fa * fc <= 0.0) {
        /* ¦ [a,c] ˺ */
        b = c; fb = fc;
      }
      else {
        /* ¦ [a,c] ˤϺʤ⤷ʤ[c,b] ˤϤ */
        a = c; fa = fc;
      }
    }
    if (j >= maxitr) {
      fprintf(stderr, "%dܤǼ\n", i+1);
      print(i, n, roots);
      exit(1);
    }
    roots[i] = a;
    a = b; b = a + 0.1;
    fa = jn(n, a); fb = jn(n, b);
  }
  print(num_of_roots, n, roots);
  return 0;
}
